package catenaNegozi;

import java.sql.*;
import java.util.*;

public abstract class Tabella {

	abstract String getNomeTabella();
	abstract String getStringaCercaPerChiave();
	abstract String getStringaInserimento();
	abstract String getStringaModifica();

	public void operazioneDML(String operazione)
			throws PersistenceException{
        Connection connection = null;
        Statement statement = null;
        try {
            connection = DataSource.getConnection();
            statement = connection.createStatement();
			System.out.println(operazione);
            statement.executeUpdate(operazione);
        } catch (SQLException sqle) {
            throw new PersistenceException(sqle);
        } finally {
            DataSource.close(statement);
            DataSource.close(connection);
        }
    }

    public void inserisci() throws PersistenceException {
        String inserimento =
            	"insert into " + getNomeTabella() + " values (" + getStringaInserimento() + ")" ;
        operazioneDML(inserimento);
    }

    public void cancella() throws PersistenceException {
        String cancellazione =
        	"delete from " + getNomeTabella() + " where " + getStringaCercaPerChiave();
        operazioneDML(cancellazione);
    }

    public void aggiorna() throws PersistenceException {
        String aggiornamento =
        	"update " + getNomeTabella() + " set " +
        	getStringaModifica()+ " where " + getStringaCercaPerChiave()  ;
        operazioneDML(aggiornamento);
    }

}



