package catenaNegozi;

import java.sql.*;
import java.util.*;

public class Produttore extends Tabella{

	String getNomeTabella(){
		return "produttori" ;
	};
	String getStringaCercaPerChiave(){
		return " codMarca = " + getCodMarca() ;
	};
	String getStringaInserimento(){
		return this.codMarca + " ,'"
            	+ this.nome +"', '" + this.nazione + "'";
	};
	String getStringaModifica(){
		return " nome = '" + this.nome +"', nazione = '" + this.nazione + "'";
	};


    private int codMarca;
    private String nome;
    private String nazione;

    public void setCodMarca(int codMarca){
        this.codMarca = codMarca;
    }

    public int getCodMarca(){
        return this.codMarca;
    }

    public void setNome(String nome){
        this.nome = nome;
    }

    public String getNome(){
        return this.nome;
    }

    public void setNazione(String nazione){
        this.nazione = nazione;
    }

    public String getNazione(){
        return this.nazione;
    }

	public static Produttore ricercaPerCodice(int codMarca)
			throws PersistenceException{
		Produttore produttore = null ;                                                		        		Connection connection = null;
		Statement statement = null;
		ResultSet resultSet = null;
		try {
			connection = DataSource.getConnection();
			statement = connection.createStatement();
			String query = "select * from produttori where codMarca = " + codMarca ;
			resultSet = statement.executeQuery(query);
			if (resultSet.next()){
				produttore = new Produttore();
				produttore.setCodMarca(codMarca);
				produttore.setNome(resultSet.getString("Nome"));
				produttore.setNazione(resultSet.getString("Nazione"));
			}
		} catch (SQLException sqle) {
			throw new PersistenceException(sqle);
		} finally {
			DataSource.close(resultSet);
			DataSource.close(statement);
			DataSource.close(connection);
		}
		return produttore;
	}

	public static List ricercaPerNome(String nome)
			throws PersistenceException{
		Produttore produttore = null ;                                                		        		Connection connection = null;
		Statement statement = null;
		ResultSet resultSet = null;
		List result = new LinkedList() ;
		try {
			connection = DataSource.getConnection();
			statement = connection.createStatement();
			String query = "select * from produttori where nome LIKE '%" + nome +"%'" ;
			System.out.println(query);
			resultSet = statement.executeQuery(query);
			while (resultSet.next()){
				produttore = new Produttore();
				produttore.setCodMarca(resultSet.getInt("codMarca"));
				produttore.setNome(resultSet.getString("Nome"));
				produttore.setNazione(resultSet.getString("Nazione"));
				result.add(produttore);
			}
		} catch (SQLException sqle) {
			throw new PersistenceException(sqle);
		} finally {
			DataSource.close(resultSet);
			DataSource.close(statement);
			DataSource.close(connection);
		}
		return result;
	}

    public String toString(){
		return 	  "codMarca: " + getCodMarca() +
			 	"\nNome:     " + getNome() +
			 	"\nNazione:  " + getNazione() ;
	}

}



