package catenaNegozi;

import java.sql.*;
import java.io.*;
import java.util.*;

class Report {
    static void stampa(){
        System.out.println("--------------------------------------------------");
        System.out.println("Elenco di produttori e prodotti");
        try {
			Connection connection = DataSource.getConnection();
			Statement statement = connection.createStatement();
			String query = "select * from produttori left join articoli on CodMarca = Produttore order by CodMarca" ;
			ResultSet resultSet = statement.executeQuery(query);
			boolean primo = true ;
			int codMarca = 0;
			int codMarcaPrec = 0;
            while (resultSet.next()){
				primo = false ;
				codMarca = resultSet.getInt("codMarca");
				if (primo || !(codMarca==codMarcaPrec)){
                System.out.println("--------------------------------------------------");
					System.out.println("Produttore: " + codMarca + " Nome: " + resultSet.getString("Nome") + " Nazione: " + resultSet.getString("Nazione") + "\nArticoli");
				}
				int matricola = resultSet.getInt("Matricola");
				if (!(resultSet.wasNull())){
					System.out.println("  " + matricola + " " + resultSet.getString("Descrizione") + " Prezzo: " + resultSet.getInt("Prezzo"));
				}
				codMarcaPrec = codMarca ;
			}
            System.out.println("--------------------------------------------------");
      } catch (SQLException pe) {
            GestoreErrori.stampaMessaggio("Errore nell'interrogazione: " + pe.toString());
        }
    }
}
